module Swap
open Heap
open ST

(* For St
kind Pre = heap -> Type
kind Post (a:Type) = heap -> a -> heap -> Type

type heap

val sel :       a:Type -> heap -> ref a -> Tot a
val upd :       a:Type -> heap -> ref a -> a -> Tot heap
val contains :  a:Type -> heap -> ref a -> Tot bool
val equal:      heap -> heap -> Tot bool

sel (upd h r v) r = v
sel (upd h r v) r' = sel h r'   if r <> r'

val read: a:Type -> r:ref a -> ST a (requires (fun h -> contains h r))
                                    (ensures (fun h0 x h1 -> h0==h1 /\ x==sel h0 r))

val write: a:Type -> r:ref a -> v:a -> ST unit
                                    (requires (fun h -> contains h r))
                                    (ensures (fun h0 x h1 -> h1==upd h0 r v))
*)

val swap_add_sub : r1:ref int -> r2:ref int -> St unit
      (requires (fun h' -> contains h' r1 /\ contains h' r2 /\ r1<>r2))
      (ensures (fun h' _ h ->
                  let x1 = sel h' r1 in
                  let x2 = sel h' r2 in
                  equal h (upd (upd h' r1 x2) r2 x1)))
let swap_add_sub r1 r2 =
  write r1 (read r1 + read r2);
  write r2 (read r1 - read r2);
  write r1 (read r1 - read r2)

(* TODO: Define a more natural variant of swap that works for
   references containing any type 'a. Give it the same specification
   as swap_add_sub, or a slightly stronger one if you can find one.
   Hint: do not use allocation for the temporary. *)

